class ball{
  float x;
  float y;
  float xvelocity;
  float yvelocity;
  float bounciness;
  color c = color(255,100,100);  // give all of the balls a pink color;
  
  ball(){
    x = random(0,width);
    y = 0;
    xvelocity = yvelocity = 0;
    bounciness = 1.0 - random(0.001,0.1);  // balls have a random bounciness slightly below 1.
  }
  
  float getX(){
    return x;
  }
  
  float getY(){
    return y;
  }
  
  void setX(int newX){
    x = newX;
  }
  
  void setPosition(int newX, int newY){
    x = newX;
    y = newY;
  }

  void collide(){
    c = color(0,0,255);  // balls in a collision turn blue
    yvelocity = yvelocity * -1;
    // Switching the yvelocity if a very primative approximation of a collision.
    // Accuracy would require calculating the angle of the collision and recalculating
    // the x and y velocities and moving the balls slightly apart, more than we want
    // to mess with.
  }
  
  void display(){
    fill(c);
    ellipse(x,y,10,10);
    c = color(255,100,100);  // reset the color to pink in case the ball had collided
  }
  
  void checkVelocity(){  // if ball is moving too slowly restart it at the top
    if(yvelocity < 5 && yvelocity > -5){
      y = 10;
    }
  }
  
  void update(){
    yvelocity = yvelocity*0.999;  // "air resistance"
    x = x + xvelocity;
    y = y + yvelocity;
    yvelocity = yvelocity + 0.1;
    if(y > height){
      yvelocity = yvelocity * (-1 * bounciness);
      y = height; // so the ball doesn't get "stuck" in the floor
      checkVelocity();
    }
  }
}
